<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev$
 * $Author$
 * $Date$
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_navigation_cache{

	static function delNavigationTree(int $id): void{
		static $deleted = [];
		if(in_array($id, $deleted)){
			return;
		}
		self::delCacheNavigationEntry(0);
		$c = 0;

		while($id != 0 && ++$c < 100 && !in_array($id, $deleted)){
			self::delCacheNavigationEntry($id);
			$deleted[] = $id;
			$id = fI('SELECT ParentID FROM ' . NAVIGATION_TABLE . ' WHERE ID=' . $id);
		}
	}

	static function delCacheNavigationEntry(int $id): void{
		we_cache_file::clean(we_cache_file::DOMAIN_NAVIGATION . $id, true);
	}

	static function saveCacheNavigation(int $id, array $naviItemes): void{
		we_cache_file::save(we_cache_file::DOMAIN_NAVIGATION . $id, $naviItemes, 0, SERIALIZE_PHP);
	}

	/**
	 *
	 * @param int $parentid
	 * @return array
	 * @throws we_exception_cache
	 */
	static function getCacheFromFile(int $parentid): array{
		return we_cache_file::load(we_cache_file::DOMAIN_NAVIGATION . $parentid);
	}

	/**
	 *
	 * @return array
	 * @throws we_exception_cache
	 */
	static function getCachedRule(): array{
		return we_cache_file::load(we_cache_file::DOMAIN_NAVIGATION . 'rules');
	}

	static function saveRules(array $rules): void{
		we_cache_file::save(we_cache_file::DOMAIN_NAVIGATION . 'rules', $rules, 0, SERIALIZE_PHP);
	}

	/**
	 * Used on upgrade to remove all navigation entries
	 */
	static function clean(bool $force = false): void{
		if(we_base_file::deleteLocalFile(WE_CACHE_PATH . 'cleannav')){
			$force = true;
		}
		if($force){
			we_cache_file::clean(we_cache_file::DOMAIN_NAVIGATION);
		}
	}

}
