<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: c564388e074d $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-07-17 13:01 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_colorChooser extends we_weTag_tag{

	/**
	 * @param array<string,mixed> $attribs parsed tag-attributes
	 * @param string $content content between openingtag and closing tag @unused-param
	 * @param bool $internal if used by we internally @unused-param
	 * @return string output to print
	 * @throws we_exception_parser if any attribute is missing
	 */
	public static function tag(array $attribs = [], string $content = '', bool $internal = false): string{
		self::attributeMissing($attribs, ['name' => false], __CLASS__);

		self::$doc = we_base_WE::getWeDoc();
		$name = self::getAttribute('name', $attribs, '', we_base_request::STRING);

		if(!self::$doc->getElementS($attribs['name']) && !empty($attribs['value'])){
			self::$doc->setElementS($attribs['name'], $attribs['value']);
		}

		if(we_base_WE::$editmode){
			$width = self::getAttribute('width', $attribs, 100, we_base_request::UNIT);
			$height = self::getAttribute('height', $attribs, 18, we_base_request::UNIT);
			return we_html_element::span(['class' => 'we we_colorChooser'], self::$doc->formColor($width, $name, 'attrib', $height));
		}
		return self::$doc->getElementS($name);
	}

}
