<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: c564388e074d $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-07-17 13:01 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_ifUserInputEmpty extends we_weTag_ifTag{

	/**
	 * @param array<string,mixed> $attribs parsed tag-attributes
	 * @param string $content content between openingtag and closing tag @unused-param
	 * @param bool $internal if used by we internally @unused-param
	 * @return string output to print
	 * @throws we_exception_parser if any attribute is missing
	 */
	public static function tag(array $attribs = [], string $content = '', bool $internal = false): bool{
		self::attributeMissing($attribs, ['match' => false], __CLASS__);
		return !self::we_isUserInputNotEmpty($attribs);
	}

	protected static function we_isUserInputNotEmpty(array $attribs): bool{
		$formname = self::getAttribute('formname', $attribs, we_base_constants::DEFAULT_FORM, we_base_request::STRING);
		$match = self::getAttribute('match', $attribs, '', we_base_request::STRING);
		$var = we_base_request::_(we_base_request::HTML, 'we_ui_' . $formname, '', $match);
		return (!empty($var));
	}

}
