<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: d5bcf73330c9 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-12-28 19:06 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_navigationWrite extends we_weTag_tag{
	/** @var ?we_navigation_items */
	static $navObj = null;

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): string{
		$name = self::getAttribute('navigationname', $attribs, 'default', we_base_request::STRING);
		$depth = self::getAttribute('depth', $attribs, 0, we_base_request::INT) ?: 0;
		$items = we_tag_navigation::getNaviItem($name);
		if($items){
			self::$navObj = $items;
			$ret = $items->writeNavigation($depth);
			self::$navObj = null;
			return $ret;
		}
		return '';
	}

}
