<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: d5bcf73330c9 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-12-28 19:06 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_search extends we_weTag_tag{

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): string{
		$name = self::getAttribute('name', $attribs, 0, we_base_request::STRING);
		$value = self::getAttribute('value', $attribs, '', we_base_request::STRING);

		$searchValue = str_replace(['"', '\\"',], '', trim(we_base_request::string('we_lv_search_' . $name, $value)));
		$attsHidden = ['type' => 'hidden',
			'name' => 'we_from_search_' . $name,
			'value' => (we_base_WE::$editmode ? 0 : 1)
		];


		switch(self::getAttribute('type', $attribs, '', we_base_request::STRING)){
			case 'print':
				return $searchValue;
			case 'textinput':
				$atts = array_merge(
					self::removeAttribs($attribs, ['type', 'onchange', 'name', 'cols', 'rows'
					]), ['name' => 'we_lv_search_' . $name,
					'type' => 'text',
					'value' => $searchValue,
				]);
				return self::htmlTag('input', $atts) . self::htmlTag('input', $attsHidden);

			case 'textarea':
				$atts = array_merge(
					self::removeAttribs(
						$attribs, ['type', 'onchange', 'name', 'size', 'maxlength', 'value'
					]), ['class' => 'defaultfont',
					'name' => 'we_lv_search_' . $name,
				]);

				return self::htmlTag('textarea', $atts, $searchValue, true) . self::htmlTag('input', $attsHidden);
		}
		return '';
	}

}
