<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: e9fb15a2aaef $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-11-15 17:36 +0100 $
 */
class we_tw_write extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName, true);
		$this->NeedsEndTag = false;

		$formname = new we_weTag_textAttribute($this, 'formname', '', false, '');
		$publish = new we_weTag_selectAttribute($this, 'publish', '', we_weTag_selectAttribute::getTrueFalse());
		$searchable = new we_weTag_selectAttribute($this, 'searchable', '', we_weTag_selectAttribute::getTrueFalse());

		$doctype = new we_weTag_sqlRowAttribute($this, 'Text', '', DOC_TYPES_TABLE, true, 'Text');
		$docTyppeId = new we_weTag_sqlRowAttribute($this, 'doctypeID', '', DOC_TYPES_TABLE, false);
		$tid = new we_weTag_selectorAttribute($this, 'tid', '', TEMPLATES_TABLE, we_base_ContentTypes::TEMPLATE, false, '');
		$categories = new we_weTag_multiSelectorAttribute($this, 'categories', '', CATEGORY_TABLE, '', 'Path', false, we_modules_info::CATEGORY);
		$classid = new we_weTag_selectorAttribute($this, 'classid', '', OBJECT_TABLE, we_base_ContentTypes::OBJECT, false, we_modules_info::OBJECT);
		$protected = new we_weTag_selectAttribute($this, 'protected', '', we_weTag_selectAttribute::getTrueFalse(), false, we_modules_info::CUSTOMER);
		$admin = new we_weTag_textAttribute($this, 'admin', '', false, '');
		$forceedit = new we_weTag_selectAttribute($this, 'forceedit', '', we_weTag_selectAttribute::getTrueFalse());
		$mail = new we_weTag_textAttribute($this, 'mail', '', false, '');
		$mailfrom = new we_weTag_textAttribute($this, 'mailfrom', '', false, '');
		$triggerid = new we_weTag_selectorAttribute($this, 'triggerid', '', FILE_TABLE, we_base_ContentTypes::WEDOCUMENT, false, '');
		$workspaces = new we_weTag_textAttribute($this, 'workspaces', '', false, '');
		$parentid = new we_weTag_selectorAttribute($this, 'parentid', '', OBJECT_FILES_TABLE, we_weTag_selectorAttribute::FOLDER, false, we_modules_info::OBJECT);
		$userid = new we_weTag_textAttribute($this, 'userid', '', false, '', '', 'number');
		$name = new we_weTag_textAttribute($this, 'name', '', false, '');
		$onduplicate = new we_weTag_selectAttribute($this, 'onduplicate', '', [
			new we_weTag_option('abort'),
			new we_weTag_option('overwrite'),
			new we_weTag_option('increment'),
			], false, '');
		$onpredefinedname = new we_weTag_selectAttribute($this, 'onpredefinedname', '', [
			new we_weTag_option('appendto'),
			new we_weTag_option('infrontof'),
			new we_weTag_option('overwrite'),
			], false, '');
		$workflowname = new we_weTag_textAttribute($this, 'workflowname', '', false, '');
		$workflowuserid = new we_weTag_textAttribute($this, 'workflowuserid', '', false, '');

		$locales = [
			new we_weTag_option('self'),
			new we_weTag_option('top')
		];
		$language = new we_weTag_choiceAttribute($this, 'language', '', $locales, false, true, '');

		$this->TypeAttribute = new we_weTag_typeAttribute($this, 'type', [
			new we_weTag_option('document', false, '', [
				$formname,
				$publish,
				$searchable,
				$language,
				$doctype,
				$docTyppeId,
				$tid,
				$categories,
				$userid,
				$admin,
				$forceedit,
				$mail,
				$mailfrom,
				$protected,
				$workflowname,
				$workflowuserid
				], []), //FIXME $doctype||$docTyppeId,
			new we_weTag_option('object', false, '', [$formname, $publish, $searchable, $language, $categories, $classid, $name, $onduplicate, $onpredefinedname, $userid,
				$admin, $forceedit, $mail, $mailfrom, $triggerid, $parentid, $protected, $workflowname, $workflowuserid], [$classid])], false, '');

		$this->Attributes = [
			$formname,
			$publish,
			$searchable,
			$language,
			$doctype,
			$docTyppeId,
			$tid,
			$categories,
			$classid,
			$protected,
			$admin,
			$forceedit,
			$mail,
			$mailfrom,
			$triggerid,
			$workspaces,
			$parentid,
			$userid,
			$name,
			$onduplicate,
			$onpredefinedname,
			$workflowname,
			$workflowuserid
		];
	}

}
