<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 6cc64d37551c $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-07-25 11:32 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
if(!defined('DB_DATABASE')){
	//load db-consts
	if(file_exists(WE_DOCUMENT_ROOT . '/webEdition/custom/conf/we_conf.inc.php')){ //FIXME: remove in cardada
		require_once(WE_DOCUMENT_ROOT . '/webEdition/custom/conf/we_conf.inc.php');
	} else {
		include_once('conf/we_conf.inc.php'); //@phan-suppress-current-line PhanMissingRequireFile
	}
}
//load global settings
if(file_exists(WE_DOCUMENT_ROOT . '/webEdition/custom/conf/we_conf_global.inc.php')){ //FIXME: remove in cardada
	require_once(WE_DOCUMENT_ROOT . '/webEdition/custom/conf/we_conf_global.inc.php');
} else {
	include_once('conf/we_conf_global.inc.php'); //@phan-suppress-current-line PhanMissingRequireFile
}
//load we-version string
include_once ('we_version.php');

define('SERIALIZE_PHP', 'serialize');
define('SERIALIZE_JSON', 'json');
define('SERIALIZE_LIST', 'list');
define('WEOBJ_PARAM', 'we_objectID');
define('WEBEDITION_DIR', '/webEdition/');

define('CSS_DIR', WEBEDITION_DIR . 'we/css/');
define('IMAGE_DIR', WEBEDITION_DIR . 'we/images/');
define('JS_DIR', WEBEDITION_DIR . 'we/js/');
define('TEMPLATES_DIR', WEBEDITION_DIR . 'generated/templates');
define('TEMP_DIR', WEBEDITION_DIR . 'temp/tmp/');
define('WE_PREVIEW_DIR', WEBEDITION_DIR . 'temp/preview/');
define('WE_APPS_DIR', WEBEDITION_DIR . 'apps/');
define('WE_BACKUP_DIR', WEBEDITION_DIR . 'generated/backup/');
define('WE_CACHE_DIR', WEBEDITION_DIR . 'temp/cache/');
define('WE_CUSTOM_DIR', WEBEDITION_DIR . 'custom/');
define('WE_INCLUDES_DIR', WEBEDITION_DIR . 'we/include/');
define('WE_LIB_DIR', WEBEDITION_DIR . 'we/libraries/');
define('WE_SITE_DIR', WEBEDITION_DIR . 'generated/site/');
define('WE_VERSION_DIR', WEBEDITION_DIR . 'generated/versions/');
define('TINYMCE_SRC_DIR', WE_LIB_DIR . 'tinymce/');
define('WE_JS_TINYMCE_DIR', JS_DIR . 'wysiwyg/tinymce/');
define('WE_JS_MODULES_DIR', JS_DIR . 'we_modules/');
define('ICON_DIR', IMAGE_DIR . 'icons/');
define('EDIT_IMAGE_DIR', IMAGE_DIR . 'edit/');

//all paths
define('JS_PATH', WE_DOCUMENT_ROOT . JS_DIR);
define('TEMPLATES_PATH', WE_DOCUMENT_ROOT . TEMPLATES_DIR);
define('TEMP_PATH', WE_DOCUMENT_ROOT . TEMP_DIR);
define('WEBEDITION_PATH', WE_DOCUMENT_ROOT . WEBEDITION_DIR);
define('WE_APPS_PATH', WE_DOCUMENT_ROOT . WE_APPS_DIR);
define('WE_BACKUP_PATH', WE_DOCUMENT_ROOT . WE_BACKUP_DIR);
define('WE_CACHE_PATH', WE_DOCUMENT_ROOT . WE_CACHE_DIR);
define('WE_CLASS_PATH', WE_DOCUMENT_ROOT . WEBEDITION_DIR . 'we/classes/');
define('WE_CUSTOM_PATH', WE_DOCUMENT_ROOT . WE_CUSTOM_DIR);
define('WE_INCLUDES_PATH', WE_DOCUMENT_ROOT . WE_INCLUDES_DIR);
define('WE_JS_MODULES_PATH', WE_DOCUMENT_ROOT . WE_JS_MODULES_DIR);
define('WE_LIB_PATH', WE_DOCUMENT_ROOT . WE_LIB_DIR);
define('WE_VERSION_PATH', WE_DOCUMENT_ROOT . WE_VERSION_DIR);

//paths without "DIRS"
define('WE_FRAGMENT_PATH', WE_DOCUMENT_ROOT . WEBEDITION_DIR . 'temp/fragments');

define('CAPTCHADEF_TABLE', TBL_PREFIX . 'tblCaptchaDef');
define('CAPTCHA_TABLE', TBL_PREFIX . 'tblCaptcha');
define('CLEAN_UP_TABLE', TBL_PREFIX . 'tblCleanUp');
define('CONTENT_TABLE', TBL_PREFIX . 'tblContent');
define('DOC_TYPES_TABLE', TBL_PREFIX . 'tblDocTypes');
define('ERROR_LOG_TABLE', TBL_PREFIX . 'tblErrorLog');
define('FAILED_LOGINS_TABLE', TBL_PREFIX . 'tblFailedLogins');
define('FILELINK_TABLE', TBL_PREFIX . 'tblFileLink');
define('FILE_TABLE', TBL_PREFIX . 'tblFile');
define('FORMMAIL_BLOCK_TABLE', TBL_PREFIX . 'tblformmailblock');
define('FORMMAIL_LOG_TABLE', TBL_PREFIX . 'tblformmaillog');
define('HISTORY_TABLE', TBL_PREFIX . 'tblhistory');
define('INDEX_TABLE', TBL_PREFIX . 'tblIndex');
define('LANGLINK_TABLE', TBL_PREFIX . 'tblLangLink');
define('LOCK_TABLE', TBL_PREFIX . 'tblLock');
define('METADATA_TABLE', TBL_PREFIX . 'tblMetadata');
define('METAVALUES_TABLE', TBL_PREFIX . 'tblMetaValues');
define('NOTEPAD_TABLE', TBL_PREFIX . 'tblwidgetnotepad');
define('PREFS_TABLE', TBL_PREFIX . 'tblPrefs');
define('PWDRESET_TABLE', TBL_PREFIX . 'tblPasswordReset');
define('RECIPIENTS_TABLE', TBL_PREFIX . 'tblRecipients');
define('SEARCHRESULT_TABLE', TBL_PREFIX . 'tblSearchResult');
define('SEARCH_TABLE', TBL_PREFIX . 'tblsearchtool');
define('SESSION_TABLE', TBL_PREFIX . 'tblSessions');
define('SETTINGS_TABLE', TBL_PREFIX . 'tblSettings');
define('TEMPLATES_TABLE', TBL_PREFIX . 'tblTemplates');
define('UPDATE_LOG_TABLE', TBL_PREFIX . 'tblUpdateLog');
define('VALIDATION_SERVICES_TABLE', TBL_PREFIX . 'tblvalidationservices');
define('VERSIONSLOG_TABLE', TBL_PREFIX . 'tblversionslog');
define('VERSIONS_TABLE', TBL_PREFIX . 'tblversions');
//category
define('CATEGORY_TABLE', TBL_PREFIX . 'tblCategorys');
//collection
define('VFILE_TABLE', TBL_PREFIX . 'tblVFile');
//customer
define('CUSTOMER_TABLE', TBL_PREFIX . 'tblWebUser');
define('CUSTOMER_FILTER_TABLE', TBL_PREFIX . 'tblcustomerfilter');
define('CUSTOMER_AUTOLOGIN_TABLE', TBL_PREFIX . 'tblWebUserAutoLogin');
define('CUSTOMER_SESSION_TABLE', TBL_PREFIX . 'tblWebUserSessions');
//export
define('EXPORT_TABLE', TBL_PREFIX . 'tblexport');
//glossary
define('GLOSSARY_TABLE', TBL_PREFIX . 'tblglossary');
//navigation
define('NAVIGATION_TABLE', TBL_PREFIX . 'tblnavigation');
define('NAVIGATION_RULE_TABLE', TBL_PREFIX . 'tblnavigationrules');
//newsletter
define('NEWSLETTER_TABLE', TBL_PREFIX . 'tblNewsletter');
define('NEWSLETTER_BLOCK_TABLE', TBL_PREFIX . 'tblNewsletterBlock');
define('NEWSLETTER_CONFIRM_TABLE', TBL_PREFIX . 'tblNewsletterConfirm');
define('NEWSLETTER_GROUP_TABLE', TBL_PREFIX . 'tblNewsletterGroup');
define('NEWSLETTER_LOG_TABLE', TBL_PREFIX . 'tblNewsletterLog');
//object
define('OBJECT_TABLE', TBL_PREFIX . 'tblObject');
define('OBJECT_FILES_TABLE', TBL_PREFIX . 'tblObjectFiles');
define('OBJECT_X_TABLE', TBL_PREFIX . 'tblObject_');
//schedule
define('SCHEDULE_TABLE', TBL_PREFIX . 'tblSchedule');
//shop
define('SHOP_ORDER_TABLE', TBL_PREFIX . 'tblOrder');
define('SHOP_ORDER_DATES_TABLE', TBL_PREFIX . 'tblOrderDates');
define('SHOP_ORDER_DOCUMENT_TABLE', TBL_PREFIX . 'tblOrderItemDocument');
define('SHOP_ORDER_ITEM_TABLE', TBL_PREFIX . 'tblOrderItem');
define('WE_SHOP_VAT_TABLE', TBL_PREFIX . 'tblshopvats');
//thumbnails
define('THUMBNAILS_TABLE', TBL_PREFIX . 'tblthumbnails');
//user
define('USER_TABLE', TBL_PREFIX . 'tblUser');
//voting
define('VOTING_TABLE', TBL_PREFIX . 'tblvoting');
define('VOTING_LOG_TABLE', TBL_PREFIX . 'tblvotinglog');
//workflow
define('WORKFLOW_TABLE', TBL_PREFIX . 'tblWorkflowDef');
define('WORKFLOW_DOC_TABLE', TBL_PREFIX . 'tblWorkflowDoc');
define('WORKFLOW_DOC_STEP_TABLE', TBL_PREFIX . 'tblWorkflowDocStep');
define('WORKFLOW_DOC_TASK_TABLE', TBL_PREFIX . 'tblWorkflowDocTask');
define('WORKFLOW_LOG_TABLE', TBL_PREFIX . 'tblWorkflowLog');
define('WORKFLOW_STEP_TABLE', TBL_PREFIX . 'tblWorkflowStep');
define('WORKFLOW_TASK_TABLE', TBL_PREFIX . 'tblWorkflowTask');

//NOTE: you have to register the tables at we.inc!
define('TEMPORARY_DOCTARGET', 'tblTemporaryDoc');

define('SESSION_NAME', 'WESESSION');
define('WE_DEFAULT_EMAIL', SMTP_MAIL_SENDER ?: 'mailserver@' . (empty($_SERVER['SERVER_NAME']) ? 'example.com' : $_SERVER['SERVER_NAME']));
define('WE_LICENSE', 'GPL');
