/* global top, fileSelect, WE, entries,writeBodyDocument */

/**
 * webEdition CMS
 *
 * $Rev: d5f9a1f5e490 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-11-18 18:43 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';

function writeBody(d) {
	switch (WE().util.dialogTop(window).fileSelect.options.view) {
		case WE().consts.selectors.VIEW_LIST:
			writeBodyDocument(d);
			break;
		default:
			var body = '';
			for (var i = 0; i < entries.length; i++) {
				body += '<div class="imgDiv ' + ((entries[i].ID == WE().util.dialogTop(window).fileSelect.data.currentID) ? "selected" : "") + '" id="line_' + entries[i].ID + '" title="' + entries[i].text + '"  onclick="return selectorOnClick(event,' + entries[i].ID + ');"' + (entries[i].isFolder ? ' ondblclick="return selectorOnDblClick(' + entries[i].ID + ');"' : "") + '>' +
					(entries[i].isFolder ? WE().util.getTreeIcon(WE().consts.contentTypes.FOLDER_COMMON) : '<img src="' + WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_base_showThumbnail&id=" + entries[i].ID + "&amp;size[width]=150&amp;path=" + entries[i].path + "&amp;extension=.jpg&amp;size[height]=200" + '" class="icon"/>') +
					'<div class="imgText selector">' + entries[i].text + '</div></div>';
			}
			d.innerHTML = '<form class="imageView" name="we_form" target="fscmd" method="post" action="' + WE().util.dialogTop(window).fileSelect.options.formtarget + '" onsubmit="document.we_form.we_FolderText.value=document.we_form.we_FolderText_tmp.value;return true;">' + body + '</form>';
			break;
	}
}

function newFile() {
	var url = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=we_fileupload_editor&we_cmd[accept]=" + WE().consts.contentTypes.IMAGE + "&we_cmd[parentid]=" + WE().util.dialogTop(window).fileSelect.data.currentDir + "&we_cmd[fixed]=1&we_cmd[writeback]=selector_insertFromUploader";
	(new (WE().layout.overlay)(window, 'top', url, "we_fileupload_editor", WE().consts.size.dialog.small, WE().consts.size.dialog.big)).setResizeable().open();
}