/* global top, WE */

/**
 * webEdition CMS
 *
 * $Rev: 16ab6a0edadd $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-11-16 22:08 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';
var filter = '';
var selectInternal = 0;

function drawNewFolder() {
	WE().util.dialogTop(window).unselectAllFiles();
	drawDir(WE().util.dialogTop(window).fileSelect.data.currentDir, "new_folder");
}

function setFilter(filter) {
	WE().util.dialogTop(window).fileSelect.data.currentFilter = filter;
	drawDir(WE().util.dialogTop(window).fileSelect.data.currentDir);
}


function selectFile(fid) {
	var i;
	if (fid !== "/") {
		WE().util.dialogTop(window).fileSelect.data.currentID = WE().util.dialogTop(window).fileSelect.data.sitepath + WE().util.dialogTop(window).fileSelect.data.rootDir + WE().util.dialogTop(window).fileSelect.data.currentDir + ((WE().util.dialogTop(window).fileSelect.data.currentDir !== "/") ? "/" : "") + fid;
		WE().util.dialogTop(window).fileSelect.data.currentName = fid;
		WE().util.dialogTop(window).document.getElementsByName("fname")[0].value = fid;
		if (WE().util.dialogTop(window).fsbody.document.getElementById(fid)) {
			for (i = 0; i < WE().util.dialogTop(window).allentries.length; i++) {
				if (WE().util.dialogTop(window).fsbody.document.getElementById(WE().util.dialogTop(window).allentries[i])) {
					WE().util.dialogTop(window).fsbody.document.getElementById(WE().util.dialogTop(window).allentries[i]).classList.remove("selected");
				}
			}
			WE().util.dialogTop(window).fsbody.document.getElementById(fid).classList.add("selected");
		}
	} else {
		WE().util.dialogTop(window).fileSelect.data.currentID = WE().util.dialogTop(window).fileSelect.data.sitepath;
		WE().util.dialogTop(window).fileSelect.data.currentName = fid;
		WE().util.dialogTop(window).document.getElementsByName("fname")[0].value = fid;
		if (WE().util.dialogTop(window).fsbody.document.getElementById(fid)) {
			for (i = 0; i < WE().util.dialogTop(window).allentries.length; i++) {
				if (WE().util.dialogTop(window).fsbody.document.getElementById(WE().util.dialogTop(window).allentries[i])) {
					WE().util.dialogTop(window).fsbody.document.getElementById(WE().util.dialogTop(window).allentries[i]).classList.remove("selected");
				}
			}
			WE().util.dialogTop(window).fsbody.document.getElementById(fid).classList.add("selected");
		}
	}
}


function reorderDir(dir, order) {
	window.setTimeout(function (url) {
		WE().util.dialogTop(window).fsbody.location = url;
	}, 100, WE().consts.dirs.WEBEDITION_DIR + 'we_cmd.php?we_cmd[0]=selectorBrowse&dir=' + dir + '&ord=' + order + '&file=' + WE().util.dialogTop(window).fileSelect.data.currentFilter + '&curID=' + encodeURI(WE().util.dialogTop(window).fileSelect.data.currentID));
}

function selectDir(path) {
	if (path) {
		WE().util.dialogTop(window).fileSelect.data.currentDir = WE().util.dialogTop(window).fileSelect.data.currentDir + (WE().util.dialogTop(window).fileSelect.data.currentDir === "/" ? "" : "/") + path;
		WE().util.dialogTop(window).addOptionh(path, WE().util.dialogTop(window).fileSelect.data.currentDir);
	}

	if (WE().util.dialogTop(window).fileSelect.data.currentDir.substring(0, 12) === "/webEdition/" || WE().util.dialogTop(window).fileSelect.data.currentDir === "/webEdition") {
		WE().layout.button.disable(document, "btn_new_dir_ss");
		WE().layout.button.disable(document, "btn_add_file_ss");
		WE().layout.button.disable(document, "btn_function_trash_ss");
	} else {
		WE().layout.button.enable(document, "btn_new_dir_ss");
		WE().layout.button.enable(document, "btn_add_file_ss");
		WE().layout.button.enable(document, "btn_function_trash_ss");
	}

	drawDir(WE().util.dialogTop(window).fileSelect.data.currentDir);

}

function goUp() {
	var a = WE().util.dialogTop(window).document.getElementById("lookin").options;
	if (a.length - 2 > -1) {
		setDir(a[a.length - 2].value);
	} else {
		WE().util.showMessage(WE().consts.g_l.fileselector.already_root, WE().consts.message.WE_MESSAGE_ERROR, window);
	}
}

function delFile(ask) {
	if ((WE().util.dialogTop(window).fileSelect.data.currentID !== "") && (WE().util.dialogTop(window).document.getElementsByName("fname")[0].value !== "")) {
		WE().util.dialogTop(window).fscmd.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=selectorBrowseCmd&cmd=delete_file&fid=" + WE().util.dialogTop(window).fileSelect.data.currentID + "&ask=" + ask;
	} else {
		WE().util.showMessage(WE().consts.g_l.fileselector.edit_file_nok, WE().consts.message.WE_MESSAGE_ERROR, window);
	}
}

function setDir(dir) {
	var a = WE().util.dialogTop(window).document.getElementById("lookin").options;
	if (a.length - 2 > -1) {
		for (var j = 0; j < a.length; j++) {
			if (a[j].value === dir) {
				a.length = j + 1;
				a[j].selected = true;
			}
		}
		switch (filter) {
			case 'folder':
			case WE().consts.contentTypes.FOLDER_DOCUMENT:
				selectFile(dir);
		}
		WE().util.dialogTop(window).fileSelect.data.currentDir = dir;
		selectDir();
	} else {
		WE().util.showMessage(WE().consts.g_l.fileselector.already_root, WE().consts.message.WE_MESSAGE_ERROR, window);
	}
}

function drawDir(dir, what, sid) {
	switch (what) {
		case "new_folder":
			WE().util.dialogTop(window).fsbody.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=selectorBrowse&dir=" + encodeURI(WE().util.dialogTop(window).fileSelect.data.rootDir + dir) + "&nf=new_folder&file=" + WE().util.dialogTop(window).fileSelect.data.currentFilter + "&curID=" + encodeURI(WE().util.dialogTop(window).fileSelect.data.currentID) + "&selectInternal=" + selectInternal;
			break;
		case "rename_folder":
			if (sid) {
				WE().util.dialogTop(window).fsbody.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=selectorBrowse&dir=" + encodeURI(WE().util.dialogTop(window).fileSelect.data.rootDir + dir) + "&nf=rename_folder&sid=" + encodeURI(sid) + "&file=" + WE().util.dialogTop(window).fileSelect.data.currentFilter + "&curID=" + encodeURI(WE().util.dialogTop(window).fileSelect.data.currentID) + "&selectInternal=" + selectInternal;
			}
			break;
		case "rename_file":
			if (sid) {
				WE().util.dialogTop(window).fsbody.location = WE().consts.dirs.WEBEDITION_DIR + "we_cmd.php?we_cmd[0]=selectorBrowse&dir=" + encodeURI(WE().util.dialogTop(window).fileSelect.data.rootDir + dir) + "&nf=rename_file&sid=" + encodeURI(sid) + "&file=" + WE().util.dialogTop(window).fileSelect.data.currentFilter + "&curID=" + encodeURI(WE().util.dialogTop(window).fileSelect.data.currentID) + "&selectInternal=" + selectInternal;
			}
			break;
		default:
			window.setTimeout(function (url) {
				WE().util.dialogTop(window).fsbody.location = url;
			}, 100, WE().consts.dirs.WEBEDITION_DIR + 'we_cmd.php?we_cmd[0]=selectorBrowse&dir=' + encodeURI(WE().util.dialogTop(window).fileSelect.data.rootDir + dir) + '&file=' + WE().util.dialogTop(window).fileSelect.data.currentFilter + '&curID=' + encodeURI(WE().util.dialogTop(window).fileSelect.data.currentID) + '&selectInternal=' + selectInternal);
	}
}